Bug 23460 - enhance pump for initrd use
enhance pump for initrd use
Product: Red Hat Linux
Classification: Retired
Component: pump (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Elliot Lee
David Lawrence
: FutureFeature
Depends On:
  Show dependency treegraph
Reported: 2001-01-05 21:01 EST by David L. Parsley
Modified: 2007-04-18 12:30 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2001-08-08 11:30:58 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
patch adding --suspend, --resume and --statefile (filename) (10.50 KB, patch)
2001-01-05 21:02 EST, David L. Parsley
no flags Details | Diff

  None (edit)
Description David L. Parsley 2001-01-05 21:01:32 EST
DHCP support is unlikely to go into the kernel, so the next best thing is
DHCP in userspace, via initrd.  To facilitate the use of pump in an initrd
which can later be freed with freeramdisk, I added options to pump for
suspending and resuming from file.

If this patch doesn't look too bad, I'll be happy to go ahead and document
and resubmit.
Comment 1 David L. Parsley 2001-01-05 21:02:50 EST
Created attachment 7123 [details]
patch adding --suspend, --resume and --statefile (filename)
Comment 2 Elliot Lee 2001-08-08 00:22:07 EDT
Thanks for the patch. Can you explain why this feature is needed? It sounds 
like some complication for possibly no gain.

Apologies for the unresponsiveness of the previous pump packager...
Comment 3 David L. Parsley 2001-08-08 11:04:19 EDT
Note: I don't think pump is the primary DHCP client for RH these days, but I'll
explain anyway ;-) (and, I think it may still be a useful patch)

This patch is to speed up and improve network-booting diskless clients:
1)etherboot/PXE does DHCP and gets kernel+ramdisk
2)ramdisk does DHCP again to get info it needs (and configure the network, of
3)ramdisk does some work to create the 'real' root filesystem, but needs to
pivot_root to get there
 -since pump is running in the first ramdisk, I have to kill it if I want to
free the old ramdisk
5)with my patch, I just tell pump to exit, but not down the interface or contact
the dhcp server; otherwise I kill pump the old way
6)pivot_root, freeramdisk
7)with my patch, I just tell pump to restart and get it's state from the file
saved in the new root, without contacting the dhcp server; otherwise I run pump
as normal again, for the 3rd dhcp request

So this just gave the cleanest/fastest behavior for my diskless boxes.

As you noted, this patch is pretty old - I'm using dhcpcd now, because it
actually writes out a file with the data from dhcp, and my ramdisk uses that
info.  Feel free to ditch this - but now you know why I did it. ;-)
Comment 4 David L. Parsley 2001-08-08 11:30:53 EDT
Sheesh, I took a look at the latest kernel.  I guess Linus changed his mind. ;-)
Comment 5 Elliot Lee 2001-09-10 20:04:48 EDT
Like you noted, pump is no longer the dhcp client for RHL in rawhide...

Note You need to log in before you can comment on or make changes to this bug.